Attribute VB_Name = "mdlCombinacionesDeTeclas"
Declare Function RegisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Declare Function UnregisterHotKey Lib "user32" (ByVal hWnd As Long, ByVal id As Long) As Long
Declare Function SetActiveWindow Lib "user32" (ByVal hWnd As Long) As Long

Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const WM_HOTKEY = &H312

Public Const MOD_ALT = &H1
Public Const MOD_CONTROL = &H2

Dim ViejoGestor As Long

Public intCantidadDeCombinaciones As Integer


Public Sub nuevoGestor(hWnd As Long)
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
ViejoGestor = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf GestorMensaje)
End Sub


Public Function GestorMensaje(ByVal hWnd As Long, ByVal mensaje As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
If (mensaje = WM_HOTKEY) Then
  If (blnFormularioModalAbierto = False) Then
    Select Case wParam
      Case 10
        'Presion la combinacin de teclas 10 (CTRL+ALT+B)
        'Oculto o pongo visible la ventana principal
        If (frmPrincipal.WindowState = 0) Then
          frmPrincipal.WindowState = 1
        Else
          If (frmPrincipal.WindowState = 1) Then frmPrincipal.WindowState = 0
        End If
      Case 0
        'Presion la combinacin de teclas 0 (CTRL+ALT+Q)
        'Muestro por 1 segundo todos los puntos grabados
        Call MostrarPuntosGrabados
      Case 1
        'Presion la combinacin de teclas 1 (CTRL+ALT+1)
        CambiarASecuencia (1)
      Case 2
        'Presion la combinacin de teclas 1 (CTRL+ALT+2)
        CambiarASecuencia (2)
      Case 3
        'Presion la combinacin de teclas 1 (CTRL+ALT+3)
        CambiarASecuencia (3)
      Case 4
        'Presion la combinacin de teclas 1 (CTRL+ALT+4)
        CambiarASecuencia (4)
      Case 5
        'Presion la combinacin de teclas 1 (CTRL+ALT+5)
        CambiarASecuencia (5)
      Case 6
        'Presion la combinacin de teclas 1 (CTRL+ALT+6)
        CambiarASecuencia (6)
      Case 7
        'Presion la combinacin de teclas 1 (CTRL+ALT+7)
        CambiarASecuencia (7)
      Case 8
        'Presion la combinacin de teclas 1 (CTRL+ALT+8)
        CambiarASecuencia (8)
      Case 9
        'Presion la combinacin de teclas 1 (CTRL+ALT+9)
        CambiarASecuencia (9)
      Case 11
        'Presion la combinacin de teclas 1 (CTRL+ALT+A)
        CambiarASecuencia (0)
      Case 12
        'Presion la combinacin de teclas 1 (CTRL+ALT+S)
        CambiarASecuencia (10)
    End Select
      SetActiveWindow hWnd
  End If
End If
GestorMensaje = CallWindowProc(ViejoGestor, hWnd, mensaje, wParam, lParam)
End Function


Public Sub RegistrarCombinacionesDeTeclas(frmForm As Form)
'Registro las combinaciones de tecla a detectar
RegisterHotKey frmForm.hWnd, 0, MOD_ALT + MOD_CONTROL, Asc("Q")  'Registro CTRL+ALT+Q con el nmero 0
RegisterHotKey frmForm.hWnd, 1, MOD_ALT + MOD_CONTROL, Asc("1")  'Registro CTRL+ALT+1 con el nmero 1
RegisterHotKey frmForm.hWnd, 2, MOD_ALT + MOD_CONTROL, Asc("2")  'Registro CTRL+ALT+2 con el nmero 2
RegisterHotKey frmForm.hWnd, 3, MOD_ALT + MOD_CONTROL, Asc("3")  'Registro CTRL+ALT+3 con el nmero 3
RegisterHotKey frmForm.hWnd, 4, MOD_ALT + MOD_CONTROL, Asc("4")  'Registro CTRL+ALT+4 con el nmero 4
RegisterHotKey frmForm.hWnd, 5, MOD_ALT + MOD_CONTROL, Asc("5")  'Registro CTRL+ALT+5 con el nmero 5
RegisterHotKey frmForm.hWnd, 6, MOD_ALT + MOD_CONTROL, Asc("6")  'Registro CTRL+ALT+6 con el nmero 6
RegisterHotKey frmForm.hWnd, 7, MOD_ALT + MOD_CONTROL, Asc("7")  'Registro CTRL+ALT+7 con el nmero 7
RegisterHotKey frmForm.hWnd, 8, MOD_ALT + MOD_CONTROL, Asc("8")  'Registro CTRL+ALT+8 con el nmero 8
RegisterHotKey frmForm.hWnd, 9, MOD_ALT + MOD_CONTROL, Asc("9")  'Registro CTRL+ALT+9 con el nmero 9
RegisterHotKey frmForm.hWnd, 10, MOD_ALT + MOD_CONTROL, Asc("B") 'Registro CTRL+ALT+B con el nmero 10
RegisterHotKey frmForm.hWnd, 11, MOD_ALT + MOD_CONTROL, Asc("A") 'Registro CTRL+ALT+A con el nmero 11
RegisterHotKey frmForm.hWnd, 12, MOD_ALT + MOD_CONTROL, Asc("S") 'Registro CTRL+ALT+S con el nmero 12
intCantidadDeCombinaciones = 13

'Activo la deteccin de combinaciones de tecla
nuevoGestor frmForm.hWnd
End Sub


Public Sub EliminarCombinacionesRegistradas(frmForm As Form)
'Elimino los registros de las combinaciones de teclas
Dim intAux As Integer
For intAux = 0 To intCantidadDeCombinaciones - 1
  UnregisterHotKey frmForm.hWnd, intAux
Next intAux
End Sub
